%%%%%%%%%%%%%%%
define _minimum()
%%%%%%%%%%%%%%%
%!%+
%\function{_minimum}
%\synopsis{computes the minimum of >=2 values}
%\usage{Array_Type _minimum(Array_Type x1, x2, ...)}
%\description
%    \code{x1}, \code{x2}, ... have to be arrays of the same length, or scalars.
%    The \code{_minimum} function returns an array of the minimum values
%    by successively calling the \code{_min} function.
%    If all \code{x1}, \code{x2}, ... are scalars, \code{_minimum} returns a scalar value, too,
%    in this case, \code{_minimum(x1, x2, ...)} is equivalent to \code{min([x1, x2, ...])}.
%\seealso{_min, min, _maximum, _max, max}
%!%-
{
  if(_NARGS<2)
    return help(_function_name());
  variable m = _min((), ());
  loop(_NARGS-2)  m = _min(m, ());
  return m;
}
