%%%%%%%%%%%%%%%
define quantile()
%%%%%%%%%%%%%%%
%!%+
%\function{quantile}
%\synopsis{gets an arbitrary quantile of an array}
%\usage{Any_Type quantile(Double_Type p, Any_Type a[]);}
%\description
%    \code{quantile(0, a) = min(a)} and \code{quantile(1, a) = max(a)}.
%    For values \code{0 < p < 1}, intermediate values of the \code{a} will be returned.
%\seealso{median}
%!%-
{
  variable p, a;
  switch(_NARGS)
  { case 2: (p, a) = (); }
  { help(_function_name()); return; }

  variable n = length(a);
  a = _reshape(a, n);
  return a[array_sort(a)[ int(_max(0, _min(p*(n-1), n-1))) ]];
}
