%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
define v_relativistic_to_optical ()
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%!%+
%\function{v_relativistic_to_optical}
%\synopsis{Convert relativistic velocity to optical velocity.}
%\usage{v_relativistic_to_optical(V_rel);}
%\description
%    Calculate the optical velocity definition from a given relativistic velocity.
%    Velocities must be given in km/s.
%!%-
{
   variable V_rel;
   switch(_NARGS)
     { case 1: V_rel = (); }
     { help(_function_name()); return; }
     %  Go from relativistic velocity definition to optical velocity...
     variable c1e5=Const_c/1e5;
   variable gamma = 1.0/sqrt( (1.0 - (V_rel/c1e5))*(1.0+(V_rel/c1e5)) );
   return c1e5 * ( gamma*(1.0 + (V_rel/c1e5)) - 1.0 );
 };
 