define radial_velocity_LSR()
%!%+
%\function{radial_velocity_LSR}
%\synopsis{computes the radial velocity component of the local standard of rest}
%\usage{Double_Type radial_velocity_LSR(Doule_Type RA, dec, MJD)
%\altusage{Double_Type radial_velocity_LSR(Doule_Type az, el, MJD, longw, lat)}
%}
%\description
%    right ascension and declination, Modified Julian Date
%    azimuth, elevation, geographic longitude (west), geographic lattitude
%!%-
{ % after SRT/geom.java
  variable RA, dec, az, el, MJD, lat, longw;
  switch(_NARGS)
  { case 3: (RA, dec, MJD) = (); }
  { case 5: (az, el, MJD, lat, longw) = ();
            (RA, dec) = RAdec_from_AzEl(az, el, MJD,  longw, lat);
  }
  { help(_function_name()); return; }

  message("THIS FUNCTION DOES NOT WORK YET!");
  message("Use at your own risk...");
  
  variable cos_dec = cos(dec);
  variable sin_dec = sin(dec);
  variable cos_RA  = cos(RA);
  variable sin_RA  = sin(RA);
                                     % sun 20km/s towards ra=18h dec=30.0
  variable x = 0.;           % 20. * cos(18.*PI/12) * cos(30.*PI/180);
  variable y = -17.3205081;  % 20. * sin(18.*PI/12) * cos(30.*PI/180);
  variable z = 10.;          % 20. * sin(30.*PI180);
  variable vsun = -x * cos_RA * cos_dec - y * sin_RA * cos_dec - z * sin_dec;

  x = cos_dec * cos_RA;
  y = cos_dec * sin_RA;
  z = sin_dec;
  (y, z) = (y * cos(23.5*PI/180)  +  z * sin(23.5*PI/180),
	    z * cos(23.5*PI/180)  -  y * sin(23.5*PI/180));
  variable soulat = atan2(z, hypot(x, y));
  variable soulong = atan2(y, x);
  variable sunlong = ((MJD-40587.)*86400.*360./(365.25*86400.) + 280.0)*PI/180;  % long=280 day 1
  return vsun - 30. * cos(soulat) * sin(sunlong - soulong);
}
