%%%%%%%%%%%%%%%%
define MJD2fermi()
%%%%%%%%%%%%%%%%
%!%+
%\function{MJD2fermi}
%\synopsis{calculate Fermi MET used for LC and spectral analysis}
%\usage{Double_Type = MJD2fermi (Double_Type);}
%\description
%	Calculates the Fermi Mission Elapsed Time (MET)
%	in seconds for a given MJD(UTC).
%\example
%	variable m = 54900.345;
%	variable fermi_s = MJD2fermi(m);
%\seealso{fermi2MJD, MJDref_satellite}
%!%-
{ 
  variable mjd_in;
  
  switch(_NARGS)
  { case 1: mjd_in  = (); }
  { help(_function_name()); return; }
  
  variable mjd_ref=51910.0; % MJD of 00:00:00 UTC 2001 January 1
  variable diff1=utc2tai(mjd_ref;mjd,deltat);
  variable diff2=utc2tai(mjd_in;mjd,deltat);
  return ((mjd_in-mjd_ref)*86400.)+diff2-diff1;
}

