%%%%%%%%%%%%%%%%%%%%%%%%%%
define init_time_structure()
%%%%%%%%%%%%%%%%%%%%%%%%%%
%!%+
%\function{init_time_structure}
%\synopsis{creates a time structure}
%\usage{Struct_Type init_time_structure(Integer_Type Y[, m[, d[, H[, M[, S]]]]])}
%\description
%    The \code{tm_year} field of the returned structure
%    is \code{Y-1900}, and \code{tm_mon} is \code{m-1}.
%\seealso{localtime, mktime, strftime}
%!%-
{
  variable Y, m=1, d=1, H=0, M=0, S=0;
  switch(_NARGS)
  { case 1: Y = (); }
  { case 2: (Y, m) = (); }
  { case 3: (Y, m, d) = (); }
  { case 4: (Y, m, d, H) = (); }
  { case 5: (Y, m, d, H, M) = (); }
  { case 6: (Y, m, d, H, M, S) = (); }
  { help(_function_name()); return; }

  return localtime(mktime(struct {
    tm_sec   = S,
    tm_min   = M,
    tm_hour  = H,
    tm_mday  = d,
    tm_mon   = m-1,
    tm_year  = Y-1900,
    tm_wday  = 0,      % will be calculated by localtime
    tm_yday  = 0,      % will be calculated by localtime
    tm_isdst = -1      % will be calculated by localtime
  }));
}
